=== debian/changelog ===
oneclient-base (19.02.5.1.ged342a5-1~bionic) bionic; urgency=low

  * Build from 19.02.5.1.ged342a5

 -- Onedata Package Maintainer <support@onedata.org>  Fri, 06 Nov 2020 22:57:49 +0100
