## oneclient-base 20.02.0.beta1

=== debian/changelog ===
oneclient-base (20.02.0.beta1-1~xenial) xenial; urgency=low

  * Build from 20.02.0.beta1

 -- Onedata Package Maintainer <support@onedata.org>  Thu, 02 Apr 2020 19:53:45 +0200
