## oneclient-base 20.02.0.beta1.3.g2fe1e60

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,12 @@
 # distro for package building (oneof: xenial, centos-7-x86_64)
-RELEASE               ?= 1902
+RELEASE               ?= 2002
 DISTRIBUTION          ?= none
 DOCKER_RELEASE        ?= development
 DOCKER_REG_NAME       ?= "docker.onedata.org"
 DOCKER_REG_USER       ?= ""
 DOCKER_REG_PASSWORD   ?= ""
 DOCKER_BASE_IMAGE     ?= "ubuntu:18.04"
-DOCKER_DEV_BASE_IMAGE ?= "onedata/worker:1902-1"
+DOCKER_DEV_BASE_IMAGE ?= "onedata/worker:2002-1"
 HTTP_PROXY            ?= "http://proxy.devel.onedata.org:3128"
 
 PKG_REVISION    ?= $(shell git describe --tags --always  --abbrev=7)
@@ -167,9 +167,8 @@
 	sed -i "s|<<PKG_SOURCE>>|../../$(PKG_ID).tar.gz|g" package/conda/oneclient/meta.yaml
 	source /opt/conda/bin/activate base && \
 		PKG_VERSION=$(PKG_VERSION) CONDA_BLD_PATH=$$PWD/package/conda-bld \
-		conda build --user onedata-devel --token "${CONDA_TOKEN}" \
+		conda build --user onedata-devel --token "${CONDA_TOKEN}" --skip-existing \
 		${CONDA_BUILD_OPTIONS} package/conda/oneclient
-	echo "onedata-devel/oneclient/$(PKG_VERSION)/download/linux-64/oneclient-$(PKG_VERSION)-0.tar.bz2" >> conda-pkg-list.txt
 
 .PHONY: conda/oneclient_centos6
 conda/oneclient_centos6: SHELL:=/bin/bash
@@ -186,9 +185,8 @@
 	sed -i '/run:/ { :l; n; s/^.*libfuse.*$$//; tx; bl; :x; N; s/\n//; bl }' package/conda/oneclient/meta.yaml
 	source /opt/conda/bin/activate base && \
 		PKG_VERSION=$(PKG_VERSION) CONDA_BLD_PATH=$$PWD/package/conda-bld \
-		conda build --user onedata-centos6-devel --token "${CONDA_TOKEN}" \
+		conda build --user onedata-centos6-devel --token "${CONDA_TOKEN}" --skip-existing \
 		${CONDA_BUILD_OPTIONS} package/conda/oneclient
-	echo "onedata-centos6-devel/oneclient/$(PKG_VERSION)/download/linux-64/oneclient-$(PKG_VERSION)_0.tar.bz2" >> conda-pkg-list.txt
 
 .PHONY: conda/onedatafs
 conda/onedatafs: SHELL:=/bin/bash
@@ -202,11 +200,8 @@
 	sed -i "s|<<PKG_SOURCE>>|../../$(PKG_ID).tar.gz|g" package/conda/onedatafs/meta.yaml
 	source /opt/conda/bin/activate base && \
 		PKG_VERSION=$(PKG_VERSION) CONDA_BLD_PATH=$$PWD/package/conda-bld \
-		conda build --user onedata-devel --token "${CONDA_TOKEN}" \
+		conda build --user onedata-devel --token "${CONDA_TOKEN}" --skip-existing \
 		${CONDA_BUILD_OPTIONS} package/conda/onedatafs
-	echo "onedata-devel/onedatafs/$(PKG_VERSION)/download/linux-64/onedatafs-$(PKG_VERSION)-py27.tar.bz2" >> conda-pkg-list.txt
-	echo "onedata-devel/onedatafs/$(PKG_VERSION)/download/linux-64/onedatafs-$(PKG_VERSION)-py36.tar.bz2" >> conda-pkg-list.txt
-	echo "onedata-devel/onedatafs/$(PKG_VERSION)/download/linux-64/onedatafs-$(PKG_VERSION)-py37.tar.bz2" >> conda-pkg-list.txt
 
 .PHONY: deb
 deb: check_distribution package/$(PKG_ID).tar.gz
@@ -289,3 +284,13 @@
 	mkdir -p $(ONECLIENT_FPMPACKAGE_TMP)/root/share/zsh/site-functions
 
 	# Collect all necessary Oneclient files in one folder
+	docker run -v $(CURDIR)/$(ONECLIENT_FPMPACKAGE_TMP)/root:/output \
+		-v $(CURDIR)/cpld.sh:/bin/cpld.sh --entrypoint /bin/cpld.sh \
+		-t docker.onedata.org/oneclient-base:$(ONECLIENT_BASE_IMAGE) \
+		/usr/bin/oneclient /output/lib
+	docker run -v $(CURDIR)/$(ONECLIENT_FPMPACKAGE_TMP)/root:/output \
+		--entrypoint /bin/bash \
+		-t docker.onedata.org/oneclient-base:$(ONECLIENT_BASE_IMAGE) \
+		-c 'cp /usr/bin/oneclient /output/bin && \
+		    cp /usr/bin/onebench /output/bin && \
+		    cp /etc/oneclient.conf /output/etc && \
