=== debian/changelog ===
oneclient-base (20.02.0.beta1.3.g2fe1e60-1~xenial) xenial; urgency=low

  * Build from 20.02.0.beta1.3.g2fe1e60

 -- Onedata Package Maintainer <support@onedata.org>  Mon, 06 Apr 2020 10:36:06 +0200
