=== debian/control ===
Source: oneclient-base
Section: net
Priority: optional
Maintainer: Onedata Package Maintainer <support@onedata.org>
Build-Depends:
    aws-sdk-cpp-s3 (>= 1.4.35),
    cmake (>= 3.0.0),
    debhelper (>= 9),
    folly-dev,
    g++-5 (>= 5.0.0),
    git,
    glusterfs-common (>= 3.12.1),
    golang-go,
    libacl1-dev,
    libboost-all-dev,
    libcurl4-openssl-dev,
    libdouble-conversion-dev,
    libfuse-dev (>= 2.7),
    libgoogle-glog-dev (>= 0.3.4),
    libiberty-dev,
    libltdl-dev,
    libnspr4-dev,
    libnss3-dev,
    libprotobuf-dev (>= 3.4.1),
    libradospp-dev (>= 14.2.2),
    libradosstriper-dev (>= 14.2.2),
    libsodium-dev,
    libssl-dev (>= 1.1.0),
    libstdc++-5-dev,
    libtbb-dev (>= 2018~U5),
    libpoco-dev,
    libpocofoundation50,
    libpoconetssl50,
    libpocoutil50,
    libpocoxml50,
    openssl (>= 1.1.0),
    pkg-config,
    protobuf-compiler (>= 3.4.1),
    python-dev,
    python3-dev,
    subversion,
    swift-sdk-cpp (>= 1.0.0),
    uuid-dev,
    wangle-dev,
    proxygen-dev
Standards-Version: 3.9.5
Homepage: https://onedata.org

Package: oneclient-base
Architecture: amd64
Depends: glusterfs-common (>= 3.12.1), ${shlibs:Depends}, ${misc:Depends}, fuse
Description: FUSE client for onedata system.
 Oneclient is a software based on FUSE (Filesystem in Userspace) that allows
 mounting onedata filesystem on Linux systems.

Package: python-onedatafs
Architecture: amd64
Depends: python, libboost-python1.58.0, ${shlibs:Depends}, ${misc:Depends}
Description: FUSE client for onedata system.
 oneclient is a software based on FUSE (Filesystem in Userspace) that allows
 mounting onedata filesystem on Linux systems.

Package: python3-onedatafs
Architecture: amd64
Depends: python3, libboost-python1.58.0, ${shlibs:Depends}, ${misc:Depends}
Description: FUSE client for onedata system.
 oneclient is a software based on FUSE (Filesystem in Userspace) that allows
 mounting onedata filesystem on Linux systems.
